-- Schema: C6Mart
-- Stored Procedure: zzzRP_DM_GestioneEmailNA

-- =============================================
-- Author:		<Luca,,Name>
-- Create date: <17/11/2008,,>
-- Description:	<Popola la tabella email con i clienti a cui deve essere inviato il report con risorse non associate,,>
-- =============================================
CREATE procedure [C6Mart].[zzzRP_DM_GestioneEmailNA]
AS
BEGIN

--INSERT INTO C6MART.LogVcontrattiseiAnd  
--	select getdate()as dtstamp,*  from c6mart.vcontrattisei where cod_fiscale + rete in (SELECT COD_FISCALE+RETE FROM C6MART.TestEmailAnd)		 

--EXECUTE C6Mart.RP_DM_GestioneEmailNA_AND


BEGIN TRANSACTION	

DECLARE @NUMGIORNIDALPERF SMALLINT
DECLARE @NUMGIORNIDASOLLECITO SMALLINT
DECLARE @MaxInvioSoll SMALLINT
DECLARE @ID_ELAB INT

SET @NUMGIORNIDALPERF = CAST(dbo.getParametro('NUMGIORNIDALPERF') as smallint)--7
SET @NUMGIORNIDASOLLECITO = CAST(dbo.getParametro('NUMGIORNIDASOLLECITO') AS SMALLINT) --7
SET @MaxInvioSoll = CAST(dbo.getParametro('MaxInvioSoll') AS SMALLINT)--12
SET @ID_ELAB = C6MART.GETIDELAB()

-- Log esecuzione
INSERT INTO LOG_ESECUZIONE
	(Nome, Inizio, Nota)
VALUES (
	'RP_DM_GestioneEmailNA',
	GETDATE(),
	'Elaborazione giornaliera'
)

-- 1. INSERIMENTO MAIL "SOLLECITI"
	-- TUPLE DA PERFEZIONARE SU CONTRATTOSEI
	-- E PRESENTI SU GESTIONE_EMAIL
	-- IL PB NON HA EFFETTUATO L'ASSOCIAZIONE DELLE RISORSE
	-- N.B. PER IL PRIMO SOLLECITO DATA_ULTIMOSOLLECITO è NULL -> CONSIDERIAMO DATA_PERF
		
	INSERT INTO C6Mart.GESTIONE_EMAIL
		(Rete,Cod_Fiscale,Tipo,Data_Generazione,ID_ELAB)
	SELECT 
		VC.rete,
		VC.cod_fiscale,
		CASE 
			WHEN ISNULL(numSolleciti,0) = 0 THEN '1_SOLL_NOASS'
			WHEN numSolleciti = 1 THEN '2_SOLL_NOASS'
			WHEN numSolleciti = 2 THEN '3_SOLL_NOASS'
			ELSE 'S_SOLL_NOASS'
		END as tipoEmail,
		getDate() as DataGenerazione,
		@ID_ELAB AS ID_ELAB
	FROM C6Mart.vcontratti VC
		INNER JOIN [C6Mart].[CONTRATTOSEI_METADATI] MD
		ON MD.chiaveclientepb = VC.chiaveclientepb
	LEFT JOIN C6MART.CODICI_PROMOTORI_FITTIZI PF
		ON VC.COD_AGENTE BETWEEN PF.CODICEDA AND PF.CODICEA
		AND VC.RETE = PF.RETE
	WHERE 1 = 1
		AND MD.numSolleciti < @MaxInvioSoll
		AND (
				(ISNULL(MD.numSolleciti,0) = 0 AND DATEDIFF(DAY,VC.Data_Perf,GETDATE()) >= @NUMGIORNIDALPERF)
				 OR
				(DATEDIFF(DAY,isnull(MD.Data_UltimoSollecito,GETDATE()),GETDATE()) >= @NUMGIORNIDASOLLECITO)
			)	
		AND MD.clienteMigrato = 'S' 
		AND MD.risorseNA = 'S'
		AND VC.Data_FineAvanzato > getDate()
		--AND VC.GenerazioneReport = 'S'
		AND PF.RETE IS NULL
		AND VC.COD_FISCALE + VC.RETE NOT IN (SELECT COD_FISCALE+RETE FROM C6MART.TestEmailAnd)
		
	-- Log esecuzione
	UPDATE
		LOG_ESECUZIONE
	SET
		Fine = GETDATE(),
		Tipo = 'INSERT',
		Righe = @@ROWCOUNT
	WHERE
		Nome = 'RP_DM_GestioneEmailNA' AND
		Inizio = (
			SELECT
				MAX(Inizio)
			FROM
				LOG_ESECUZIONE
			WHERE
				Nome = 'RP_DM_GestioneEmailNA'
		)

	INSERT INTO LOG_ESECUZIONE
		(Nome, Inizio, Nota)
	VALUES (
		'RP_DM_GestioneEmailNA',
		GETDATE(),
		'Elaborazione giornaliera'
	)

-- 1.BIS UPDATE CONTRATTOSEI DOPO INSERIMENTO MAIL "SOLLECITI"
	-- AUMENTIAMO IL NUMERO numSolleciti
	-- AGGIORNIAMO LA DATA Data_UltimoSollecito

	UPDATE 
		c6mart.CONTRATTOSEI_METADATI
	SET 
		numSolleciti = isnull(numSolleciti,0) + 1,
		Data_UltimoSollecito = getDate()
	FROM C6Mart.vcontratti VC
	INNER JOIN [C6Mart].[CONTRATTOSEI_METADATI] MD
		ON MD.chiaveclientepb = VC.chiaveclientepb
	LEFT JOIN C6MART.CODICI_PROMOTORI_FITTIZI PF
		ON VC.COD_AGENTE BETWEEN PF.CODICEDA AND PF.CODICEA
		AND VC.RETE = PF.RETE
	WHERE 1 = 1
		AND MD.numSolleciti < @MaxInvioSoll
		AND (
				(ISNULL(MD.numSolleciti,0) = 0 AND DATEDIFF(DAY,VC.Data_Perf,GETDATE()) >= @NUMGIORNIDALPERF)
				 OR
				(DATEDIFF(DAY,isnull(MD.Data_UltimoSollecito,GETDATE()),GETDATE()) >= @NUMGIORNIDASOLLECITO)
			)
		AND MD.clienteMigrato = 'S' 
		AND MD.risorseNA = 'S'
		AND VC.Data_FineAvanzato > getDate()
		--AND VC.GenerazioneReport = 'S'
		AND PF.RETE IS NULL
		AND
